package Turtle;


use strict;
use constant PI             => 4 * atan2 1, 1;


sub new
{
	my $class=shift;
	my $self={};
	@{$self}{qw(x y theta mirror)}=@_;
	$self->{anglescale} = 1;
	bless $self, $class;
}

sub forward
{
	my $self=shift;
	my ($r, $what)=@_;
	my ($newx, $newy)=($self->{x}+$r* sin($self->{theta}),
			   $self->{y}+$r*-cos($self->{theta}));
	if ($what)
	{
		&$what($self->{x}, $self->{y}, $newx, $newy);	# Do something related to motion
	}							# According to the coderef passed in
	($self->{x}, $self->{y})=($newx, $newy);		# And change the old coords
}

sub turn
{
	my $self=shift;
	my $dtheta= $self->{anglescale} * shift;

	$self->{theta}+=$dtheta*$self->{mirror};
}

sub state
{
	my $self=shift;
	@{$self}{qw(x y theta mirror anglescale)};
}

sub setstate
{
	my $self=shift;
	@{$self}{qw(x y theta mirror)}=@_;
	$self->{theta} *= $self->{anglescale};
}

sub mirror
{
	my $self=shift;
	$self->{mirror}*=-1;
}

sub radians
{
	my $self=shift;
	$self->{anglescale} = 1;
}

sub dsin
{
	return sin( $_[0] * $Turtle::d2r );
}

sub degrees
{
	my $self=shift;
	$self->{anglescale} = $Turtle::d2r;
}

$Turtle::d2r = PI/180;

1;
