package col;


use strict;
use vars qw($white $black $blue $cyan @colour);


sub read ($$)
{
	my( $im, $filename ) = @_;
	my( $r, $g, $b );

	@colour = ( );

	$white = $im->colorAllocate( 255, 255, 255 );
	$black = $im->colorAllocate( 0, 0, 0 );
	$blue = $im->colorAllocate( 0, 0, 255 );
	$cyan =	$im->colorAllocate( 0, 255, 255 );

	unless( open( IN, $filename ) )
	{
		@colour = (
			$black,
			$white,
		);
		return;
	}

	my %colourlookup = (
		'black' => [ 0, 0, 0 ],
		'white' => [ 255, 255, 255 ],
		'cyan' => [ 0, 255, 255 ],
		'yellow' => [ 255, 255, 0 ],
		'purple' => [ 255, 0, 255 ],
		'red' => [ 255, 0, 0 ],
		'green' => [ 0, 255, 0 ],
		'blue' => [ 0, 0, 255 ],
		'grey' => [ 127, 127, 127 ],
		'burgundy' => [ 127, 0, 127 ],
		'aquamarine' => [ 0, 127, 127 ],
		'darkblue' => [ 0, 0, 127 ],
		'darkgreen' => [ 0, 127, 0 ],
	);

	while( <IN> )
	{
		chomp;
		s/^\s+//;
		s/\s+$//;
		if( /^(\w+)\s+(\w+)\s+(\w+)$/ )
		{
			( $r, $g, $b ) = ( $1, $2, $3 );
		} else
		{
			my $ref = $colourlookup{$_};
			if( $ref )
			{
				( $r, $g, $b ) = @$ref;
			} else
			{
				warn "Error in $filename - line '$_'\n";
				next;
			}
		}
		push( @colour, $im->colorAllocate( $r, $g, $b ) );
	}

	close( IN );
}


1;
