#!/usr/bin/perl
#
# abstractart1.cgi:	produce and display a mondrian-style image made up
#			of random lines and filled boxes
#
#	(C) Duncan C. White, 23rd February 1999
#
use GD;
use webprompt;
use col;


sub intrand ($) { return $_[0]<1?0:int(rand($_[0])); }

&webprompt::get(
	"abstractart1", "Mondrian-style Abstract Art",
	\&giveback, \&validate, \&createimg,
	qw(X Y Palette=RBY|RBYB|RBYBB|green MinBoxes MaxBoxes MinThickness MaxThickness) );

exit 0;


sub giveback ($$$$$$$)
{
	my( $x, $y, $palette, $minboxes, $maxboxes, $minthick, $maxthick ) = @_;
	
	$p'x = $x;
	$p'y = $y;
	$p'palette = $palette;
	$p'minboxes = $minboxes;
	$p'maxboxes = $maxboxes;
	$p'minthick = $minthick;
	$p'maxthick = $maxthick;

	return @_;
}


sub validate ()
{
	return "" if $p'x > 50 && $p'y > 50 && $p'minboxes > 0 &&
		$p'maxboxes >= $p'minboxes && $p'minthick > 0 &&
		$p'maxthick >= $p'minthick;
	return "These values are not sensible";
}


sub createimg ()
{
	$p'XD = $p'x/10;
	$p'YD = $p'y/10;

	$im = new GD::Image($p'x--, $p'y--);

	col::read( $im, $p'palette );

	#$im->transparent($col'white);
	$im->interlaced('true');

	my $boxes = $p'minboxes + intrand(1+$p'maxboxes-$p'minboxes);

	for( my $i = 0; $i < $boxes; $i++ )
	{
		onebox();
	}

	return $im;
}


sub onebox
{
	my( $thick, $x, $y, $x2, $y2, $col );

	$thick = $p'minthick + rand(1+$p'maxthick-$p'minthick);

	$x = rand($p'x-2*$p'XD);
	$y = rand($p'y-2*$p'YD);
	$x2 = $x + $p'XD + rand($p'XD);
	$y2 = $y + $p'XD + rand($p'YD);
	$col = $col'colour[rand(@col'colour)];

	my $th = $thick-1;
	$im->filledRectangle( 0, $y, $p'x, $y+$th, $col'black );
	$im->filledRectangle( 0, $y2-$th, $p'x, $y2, $col'black );
	$im->filledRectangle( $x, 0, $x+$th, $p'y, $col'black );
	$im->filledRectangle( $x2-$th, 0, $x2, $p'y, $col'black );

	$im->filledRectangle( $x + $thick, $y + $thick,
			      $x2 - $thick, $y2 - $thick, $col );
}
